=== Tests/RunCMake/CMP0111/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
project(${RunCMake_TEST} CXX)
include(${RunCMake_TEST}.cmake)
