=== Tests/RunCMake/include/subdir1/CMakeLists.txt ===

export(TARGETS foo FILE "${CMAKE_CURRENT_BINARY_DIR}/theTargets.cmake")
