=== Tests/RunCMake/project/subdir1/CMakeLists.txt ===
project(${RunCMake_TEST} LANGUAGES NONE)
